(define (cel2fahr f)
	(- (* (+ f 40) 1.8) 40)
)
(define (fahr2cel f)
	(- (/ (+ f 40) 1.8) 40)
)

(define pi 3.1415)

(define (u2r u) (/ u (* 2 pi)))

(define (r-d u1 u2) (- (u2r u1) (u2r u2)))

(define (p x) (p (+ x 1)))
(define (test x y) (if (= x 0) 0 y))

(define (new-if condition? then-clause else-clause)
	(cond (condition? then-clause) (else else-clause))
)

(define (divide x y) (new-if (and (> y 0) (> x y))
																(/ x y)
																1
										  )
)

(define (divides? x y) (= (remainder y x) 0))


(define (square x) (* x x))

(define (next-divisor y x)
(cond
				((divides? x y) x)
				((> (square x) y) y)
				(else (next-divisor y (+ x 1)))))


(define (prime? x) (= (next-divisor x 2) x))
