knoten(10, 7, 15).
knoten(7, 3, 8).
knoten(3, 2, nil).
knoten(2, 1, nil).
knoten(15, 14, 22).
knoten(8, nil, nil).
knoten(1, nil, nil).
knoten(14, nil, nil).
knoten(22, nil, 27).
knoten(27, nil, nil).

vorgaenger(X) :- (knoten(_, X, _) ; knoten(_, _, X)), X\= nil.

vorgaenger(X, Y) :- knoten(X, Y, _) ; knoten(X, _, Y).

wurzel(X) :- knoten(X, _, _), \+vorgaenger(X).

pfad(X, Y) :- knoten(X, Y, _); knoten(X, _, Y).
pfad(X, Y) :- (knoten(X, Z, _) ; knoten(X, _, Z)), pfad(Z, Y).

gleiche_ebene(X, X).
gleiche_ebene(X, Y) :- vorgaenger(V1, X), vorgaenger(V2, Y), gleiche_ebene(V1, V2), X \= Y.

ebene(X, 0) :- wurzel(X).
ebene(Knoten, N) :- vorgaenger(Vorg, Knoten), ebene(Vorg, N2), N is N2 + 1.
