

frau(mizuho).
frau(marie).
frau(konoha).
frau(hatsuho).
frau(maho).
frau(koishi).

%   Foreign: rl_add_history/1


mann(kei).
mann(minoru).

%   Foreign: rl_read_init_file/1


mutter(hatsuho, mizuho).
mutter(hatsuho, maho).
mutter(maho, koishi).


liebt(kei, mizuho).
liebt(kei, konoha).
liebt(kei, minoru).
liebt(mizuho, kei).
liebt(mizuho, hatsuho).
liebt(mizuho, maho).
liebt(mizuho, marie).
liebt(marie, mizuho).
liebt(maho, mizuho).
liebt(maho, hatsuho).
liebt(hatsuho, mizuho).
liebt(hatsuho, maho).
liebt(konoha, kei).
liebt(konoha, minoru).
liebt(minoru, konoha).
liebt(minoru, kei).
liebt(koishi, kei).


verwandt(A, B) :-
	(   mutter(A, B)
	;   onkel(A, B)
	;   tante(A, B)
	).
verwandt(A, B) :-
	(   mutter(B, A)
	;   onkel(B, A)
	;   tante(B, A)
	).

verwandt(A, B) :- verwandt(A, X), verwandt(X, B).

tante(konoha, kei).


onkel(minoru, kei).


paar(A, B) :-
	liebt(A, B),
	liebt(B, A),
	(   mann(A),
	    frau(B)
	;   mann(B),
	    frau(A)
	),
	\+verwandt(A, B).


paar(A) :-
	liebt(A, B).
